<meta property="og:description" content="Using your standard 2FA app with Steam"/>
<title>Using your standard 2FA app with Steam</title>
</head>
<body>
	<div id="main">
		<h1>Using your standard 2FA app with Steam</h1>
		<h2>Overview</h2>
		<p>
		We'll remove your existing Steam Guard, generate a shared
		secret via the Steam API, add it to your favorite 2FA application and
		verify that it works, then require the use of 2FA for Steam.
		</p>

		<h2>Implementation</h2>
		<p>
		Remove your existing Steam Guard via the mobile app (Steam Guard > Remove Authenticator).
		<br><br>

		Install the Steam API, potentially after reviewing the code a bit:
		</p>
		<code>
			<pre>
pip install git+https://github.com/ValvePython/steam#egg=steam </pre>
		</code>

		<p>
		Open a Python shell (we'll want to run some code dynamically) and get a connection to steam:
		</p>
		<code>
			<pre>
$ python
>>> import steam
>>> import steam.webauth as wa
>>> import steam.guard as guard
>>> wa = wa.MobileWebAuth("USERNAME", "PASSWORD")
>>> wa.cli_login() </pre>
		</code>
		<p>
		This will wait for you to enter a code that was emailed to you.<br><br>

		Initiate a Steam Authenticator for your account (this won't make it required yet):
		</p>
		<code>
			<pre>
>>> sa = guard.SteamAuthenticator(backend=wa)
>>> sa.add()
>>> print("Shared secret", sa.secrets["shared_secret"])
>>> print("Revocation code", sa.secrets["revocation_code"]) </pre>
		</code>
		<p>
		You'll want to save the revocation code somewhere before continuing.  If you lose this code, you'll have no way to login to your account.
		<br><br>

		Now, add this key to your 2FA application of choice.  If you are using <a href="https://github.com/beemdevelopment/Aegis">Aegis</a>, you'll need to convert it to base32 first:
		</p>
		<code>
			<pre>
>>> import base64
>>> base64.b32encode(base64.b64decode(sa.secrets["shared_secret"])).decode("utf-8")</pre>
		</code>

		<p>
		Your 2FA application should now be generating codes, so let's confirm that they're correct.  Run the following a few times and make sure the results match your application:
		</p>
		<code>
			<pre>
>>> sa.get_code() </pre>
		</code>
		</p>

		<h2>Enabling 2FA</h2>
		<p>
		If everything looks good, let's turn 2FA on for good.  You should have received a code via SMS to use here:
		</p>
		<code>
			<pre>
>>> sa.finalize("SMS CODE HERE") </pre>
		</code>

		<p>
		Logout and log back in, at which point you should be able to use your new 2FA app!
		</p>
